/***************************************************************************
****************************************************************************
*   File: H:\111111111111\example\CE118_FIR_Filter\CE118_FIR_Filter\src\filter1.c
*   Created by dsPIC FD Lite Version 1.0.0 Build 1 at 16:26:13 Dec 15 2011
*   C Code Generator - Version 4.0  
****************************************************************************
*  Code Fragment to implement filter
*
*  The functions defined in 'qed_filt.c' must be compiled and linked in.
*    This can be accomplished by either #include "qed_filt.c"
*    or by separately compiling and linking 'qed_filt.c'
*
*** following is actual code fragment
*  extern FIR_filter FIR_filter1;
*
*  init_fir_float (&FIR_filter1);  // initialize filter structure 
*
*  FIR_filter1.filter ( x, y, n, &FIR_filter1);  // x is an array of input samples
*                                            // y is an array of output samples
*                                            // n is number of samples to process
*                                            // &FIR_filter1 is a pointer to the
*                                            //    filter structure
*****************************************************************************
*  This is a complete program which can be compiled and run to test the filter.
*  To change this to a subroutine only, just add in this program or add globally
*     in "qed_cgen.h" the line with the definition of DEFINE_SUBROUTINE as follows
*  #define DEFINE_SUBROUTINE
*****************************************************************************
****************************************************************************/

/* qed_cgen.h contains definitions of filter structures and function prototypes */
#include "qed_cgen.h"

/* filter functions are in files 'qed_filt.c'  */

float filter1_coeff[64] = {
  -5.676269531250e-003F,  /* filter tap #    0 */
  -9.307861328125e-003F,  /* filter tap #    1 */
  -1.284790039063e-002F,  /* filter tap #    2 */
  -1.620483398438e-002F,  /* filter tap #    3 */
  -1.931762695313e-002F,  /* filter tap #    4 */
  -2.209472656250e-002F,  /* filter tap #    5 */
  -2.447509765625e-002F,  /* filter tap #    6 */
  -2.639770507813e-002F,  /* filter tap #    7 */
  -2.780151367188e-002F,  /* filter tap #    8 */
  -2.865600585938e-002F,  /* filter tap #    9 */
  -2.893066406250e-002F,  /* filter tap #   10 */
  -2.859497070313e-002F,  /* filter tap #   11 */
  -2.761840820313e-002F,  /* filter tap #   12 */
  -2.609252929688e-002F,  /* filter tap #   13 */
  -2.395629882813e-002F,  /* filter tap #   14 */
  -2.130126953125e-002F,  /* filter tap #   15 */
  -1.815795898438e-002F,  /* filter tap #   16 */
  -1.458740234375e-002F,  /* filter tap #   17 */
  -1.065063476563e-002F,  /* filter tap #   18 */
  -6.469726562500e-003F,  /* filter tap #   19 */
  -2.075195312500e-003F,  /* filter tap #   20 */
   2.349853515625e-003F,  /* filter tap #   21 */
   6.805419921875e-003F,  /* filter tap #   22 */
   1.116943359375e-002F,  /* filter tap #   23 */
   1.531982421875e-002F,  /* filter tap #   24 */
   1.919555664063e-002F,  /* filter tap #   25 */
   2.267456054688e-002F,  /* filter tap #   26 */
   2.569580078125e-002F,  /* filter tap #   27 */
   2.822875976563e-002F,  /* filter tap #   28 */
   3.015136718750e-002F,  /* filter tap #   29 */
   3.146362304688e-002F,  /* filter tap #   30 */
   3.213500976563e-002F,  /* filter tap #   31 */
   3.213500976563e-002F,  /* filter tap #   32 */
   3.146362304688e-002F,  /* filter tap #   33 */
   3.015136718750e-002F,  /* filter tap #   34 */
   2.822875976563e-002F,  /* filter tap #   35 */
   2.569580078125e-002F,  /* filter tap #   36 */
   2.267456054688e-002F,  /* filter tap #   37 */
   1.919555664063e-002F,  /* filter tap #   38 */
   1.531982421875e-002F,  /* filter tap #   39 */
   1.116943359375e-002F,  /* filter tap #   40 */
   6.805419921875e-003F,  /* filter tap #   41 */
   2.349853515625e-003F,  /* filter tap #   42 */
  -2.075195312500e-003F,  /* filter tap #   43 */
  -6.469726562500e-003F,  /* filter tap #   44 */
  -1.065063476563e-002F,  /* filter tap #   45 */
  -1.458740234375e-002F,  /* filter tap #   46 */
  -1.815795898438e-002F,  /* filter tap #   47 */
  -2.130126953125e-002F,  /* filter tap #   48 */
  -2.395629882813e-002F,  /* filter tap #   49 */
  -2.609252929688e-002F,  /* filter tap #   50 */
  -2.761840820313e-002F,  /* filter tap #   51 */
  -2.859497070313e-002F,  /* filter tap #   52 */
  -2.893066406250e-002F,  /* filter tap #   53 */
  -2.865600585938e-002F,  /* filter tap #   54 */
  -2.780151367188e-002F,  /* filter tap #   55 */
  -2.639770507813e-002F,  /* filter tap #   56 */
  -2.447509765625e-002F,  /* filter tap #   57 */
  -2.209472656250e-002F,  /* filter tap #   58 */
  -1.931762695313e-002F,  /* filter tap #   59 */
  -1.620483398438e-002F,  /* filter tap #   60 */
  -1.284790039063e-002F,  /* filter tap #   61 */
  -9.307861328125e-003F,  /* filter tap #   62 */
  -5.676269531250e-003F}; /* filter tap #   63 */

float filter1_smpl[64];  /* sample delay line */ 

float filter1_gain = 1.000000000000e+000F; /* gain multiplier for FIR realization */

FIR_filter FIR_filter1 = {

     0,     /* quantization: 0 off, 1 on   */
     1,     /* quantization type */
            /*   0  Floating point         */
            /*   1  Fixed point fractional */
     0,     /* quantization type */
            /*   0 - No scaling of filter */
            /*   1 - Center tap scaled to be > 0.5 and < 1.0  */
            /*   2 - Center tap scaled to be 1.0 - gain factor
                     (essentially largest positive value) */
   0,           /* shift count - fixed point fractional */ 
   64,           /* filter length */ 
   0,            /* initial delay line index */
   &filter1_gain,  /* ptr to gain value          */
   filter1_coeff,  /* ptr to filter coefficients */
   filter1_smpl,   /* ptr to delay line */
   fir_float_reg}; /* ptr to filter routine */

/* call the following function first and normally only once */
/* init_fir_float (&FIR_filter1)  */
/*   where &FIR_filter1 is a pointer to the FIR_filter */
/*   structure defining the filter */


/* call the following function to filter n samples */
/* FIR_filter1.filter (pIn, pOut, int n, &FIR_filter1); */

/*   where pIn  is a pointer to an array or buffer of samples to be filtered */
/*         pOut is a pointer to the array of filtered samples output by the filter */
/*         n    is the number of samples to filter */
/*         &FIR_filter1 is a pointer to the structure defining the filter */


#ifndef DEFINE_SUBROUTINE

/* The following main program can be used to test the filter.         */
/*   input is in file 'in' and the filtered samples are in file 'out' */
/*   The input and output files are ascii floating point values       */
/*    e.g 1.0342 with 1 sample per line                               */
/* The input files can be created in DSPworks and exported as         */
/*   ascii floating point or any other system capable of creating     */
/*   ascii files with floating point values.                          */
/* The filtered output file can be imported into DSPworks as an ascii */
/*    floating point file and an FFT can be run to validate           */
/*    the frequency response.                                         */

#include "qed_filt.c"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>


#define INSZ1  1000
#define OUTSZ1 1000

static    float x[INSZ1], y[OUTSZ1];


int main(int argc, char *argv[])

{
  int i, in_count, file_status, error;

  FILE *fin;              /* input file of samples */
  FILE *fout;             /* output file of filtered samples */ 

  fprintf (stderr," ***** start filter test *****\n");

  fprintf (stderr," this program accepts 0,1 or 2 command line arguments\n");
  fprintf (stderr," the first  argument is the filename of the input file\n");
  fprintf (stderr," the second argument is the filename of the output file\n");
  fprintf (stderr," if there are 0 arguments, input and output is respectively\n");
  fprintf (stderr,"     stdin and stdout\n");
  fprintf (stderr," if only one argument is specified, then output is stdout\n");
  fprintf (stderr," if input is stdin rather than a file, then fscanf expects input\n");
  fprintf (stderr,"     from the console which may be piped in or entered directly\n");

  fin  = stdin;
  fout = stdout;
  error = 0;

  if (argc == 1) {
	    fprintf(stderr," ***** waiting for input *****\n");
  }
  if (argc >= 2) {
      fin = fopen (argv[1], "r");
      if (fin == NULL) {
          fprintf(stderr,"\n error - Cannot open file %s for input\n", argv[1]);
          error = 1;
      }
  }
  if (argc >= 3) {
      fout = fopen (argv[2], "w");
      if (fout == NULL) {
          fprintf(stderr,"\n error - Cannot open file %s for output\n", argv[2]);
          error = 1;
      }
  }
  if (error) {
      fprintf(stderr," ***** end filter test *****\n");
      return(0);
  }
  
  

  init_fir_float (&FIR_filter1);


  do {

      /* get input samples */ 
      for (in_count = 0; in_count < INSZ1; in_count++) { 
          file_status = fscanf(fin,"%f",&x[in_count]); 
          if (file_status != 1) 
              break; 
      }

      /* filter samples */ 

      if (in_count == 0) break;

      FIR_filter1.filter( x, y, in_count, &FIR_filter1);

      for (i = 0; i < in_count; i++)
          fprintf (fout,"%f\n",y[i]);

  } while (file_status == 1);

  fclose (fin); 
  fclose (fout);

  fprintf(stderr," ***** end filter test *****\n");
  return(1);

}
 
#endif 
