#include "p33Fxxxx.h"
#include <stdint.h>
void __delay32(unsigned long cycles);
#define SYS_FREQ 80000000UL
#define FCY SYS_FREQ/2
#define delay_us(x) __delay32(((x*FCY)/1000000L))

_FOSCSEL(0x02);
_FOSC(0xE2);

unsigned int Buffer[256], i = 0;


int main(void)
{

	AD1PCFGL = 0b011111111;			//  AN8   

	AD1CON2bits.VCFG = 0b000;		//   
	AD1CON2bits.CHPS = 0b00;		//     CH0
	AD1CON1bits.SSRC = 0b000;		//  
	AD1CON1bits.ASAM = 0;			//  
	AD1CON3bits.ADRC = 1;			//      

	AD1CON2bits.SMPI = 0b0000;		//    
	AD1CON3bits.SAMC = 0b11111;		//   31Tad
	AD1CON3bits.ADCS = 0b11111111;	// Tad = 256*Tcy

	AD1CHS0bits.CH0SA = 8;			//      AN8
	AD1CHS0bits.CH0NA = 0;			//     Vref-

	AD1CON1bits.FORM = 0b00;		//    

	_AD1IF = 0;						//    
	_AD1IP = 1;						//   
	_AD1IE = 1;						//    

	AD1CON1bits.ADON = 1;			//   
	// AD1CON1bits.SAMP = 1;		//  

	delay_us(100);

	while(1)
	{
		AD1CON1bits.SAMP = 1;		//  
		delay_us(10);				//   
		AD1CON1bits.SAMP = 0;		//  
		while (!AD1CON1bits.DONE);	//   
		Buffer[i] = ADC1BUF0;			//    
		i++;							//    
		if(i == 256) delay_us(0);
		i %= 256;						//  
	}
}

//  
void __attribute__((__interrupt__,auto_psv)) _ADC1Interrupt(void)
{

	_AD1IF = 0;						//    
}
