#include <stdint.h>
#include "p33Fxxxx.h"
#include "insig.h"
#include "coeff.h"

_FOSCSEL(0x02);
_FOSC(0xE2);


int main(void)
{
	extern const int input_signal[1024];
	extern const float filter_coeff[61];
	float output_signal[1024];
	int i = 0, j = 0;

	for(j = 0; j < 1024; j++)
		for(i = 0; i < 61; i++){
			if (j-i < 0) continue;
			output_signal[j] += filter_coeff[i]*input_signal[j-i];
		};

	return 0;
}
